Gentoo Forums
Gentoo Forums
Gentoo Forums
Quick Search: in
blender-2.58a-r2.ebuild estavel com novos parches
View unanswered posts
View posts from last 24 hours
View posts from last 7 days

 
Reply to topic    Gentoo Forums Forum Index Portuguese
View previous topic :: View next topic  
Author Message
Oicraman
n00b
n00b


Joined: 14 Apr 2011
Posts: 20

PostPosted: Fri Jul 22, 2011 8:58 pm    Post subject: blender-2.58a-r2.ebuild estavel com novos parches Reply with quote

Ola galera, I criei um ebuild novo da versao 2.58 do Blender, com novos parches pra poder instalar corretamente esta versao no nosso Gentoo.

Se você tiver alguma duvida ou sugestão, responde deixando o seu comentario!

Flw

blender-2.58a-r2.ebuild
Code:

# Copyright 1999-2010 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

PYTHON_DEPEND="3:3.2"
EAPI=3

inherit eutils python versionator flag-o-matic toolchain-funcs

IUSE="+game-engine player +elbeem +openexr ffmpeg jpeg2k openal openmp \
   +dds debug fftw jack apidoc sndfile lcms tweak-mode sdl sse \
   redcode +zlib iconv contrib"
#   redcode +zlib iconv contrib collada test"

DESCRIPTION="3D Creation/Animation/Publishing System"
HOMEPAGE="http://www.blender.org"
SRC_URI="http://download.blender.org/source/${P}.tar.gz"

SLOT="2.5"
LICENSE="|| ( GPL-2 BL )"
KEYWORDS="~amd64 ~amd64-fbsd ~ppc ~ppc64 ~x86 ~x86-fbsd"

RDEPEND="virtual/jpeg
   media-libs/libpng
   x11-libs/libXi
   x11-libs/libX11
   media-libs/tiff
   media-libs/libsamplerate
   virtual/opengl
   >=media-libs/freetype-2.0
   virtual/libintl
   media-libs/glew
   dev-cpp/eigen:2
   >=sci-physics/bullet-2.76
   iconv? ( virtual/libiconv )
   zlib? ( sys-libs/zlib )
   sdl? ( media-libs/libsdl[audio,joystick] )
   openexr? ( media-libs/openexr )
   ffmpeg? (
      >=virtual/ffmpeg-0.6.90[x264,mp3,encode,theora]
      jpeg2k? ( >=virtual/ffmpeg-0.6.90[x264,mp3,encode,theora,jpeg2k] )
   )
   openal? ( >=media-libs/openal-1.6.372 )
   fftw? ( sci-libs/fftw:3.0 )
   jack? ( media-sound/jack-audio-connection-kit )
   sndfile? ( media-libs/libsndfile )
   lcms? ( media-libs/lcms )"

DEPEND=">=dev-util/scons-0.98
   apidoc? (
      dev-python/sphinx
      >=app-doc/doxygen-1.5.7[-nodot]
   )
   x11-base/xorg-server
   ${RDEPEND}"

blend_with() {
   local UWORD="$2"
   [ -z "${UWORD}" ] && UWORD="$1"
   if useq $1; then
      echo "WITH_BF_${UWORD}=1" | tr '[:lower:]' '[:upper:]' \
         >> "${S}"/user-config.py
   else
      echo "WITH_BF_${UWORD}=0" | tr '[:lower:]' '[:upper:]' \
         >> "${S}"/user-config.py
   fi
}

pkg_setup() {
   enable_openmp=0
   if use openmp; then
      if tc-has-openmp; then
         enable_openmp=1
      else
         ewarn "You are using gcc built without 'openmp' USE."
         ewarn "Switch CXX to an OpenMP capable compiler."
         die "Need openmp"
      fi
   fi
   python_set_active_version 3
}

src_prepare() {
   epatch "${FILESDIR}"/${PN}-desktop.patch
   epatch "${FILESDIR}"/${PN}-${SLOT}-doxyfile.patch

   # TODO: write a proper Makefile to replace the borked bmake script
   epatch "${FILESDIR}"/${PN}-${SLOT}-bmake.patch

   # OpenJPEG
   einfo "Removing bundled OpenJPEG ..."
   rm -r extern/libopenjpeg

   # Glew
   einfo "Removing bundled Glew ..."
   rm -r extern/glew
   epatch "${FILESDIR}"/${PN}-${SLOT}-glew.patch

   # Eigen2
   einfo "Removing bundled Eigen2 ..."
   rm -r extern/Eigen2
   epatch "${FILESDIR}"/${PN}-${SLOT}-eigen.patch
}

src_configure() {
   # add system openjpeg into Scons build options.
   cat <<- EOF >> "${S}"/user-config.py
      BF_OPENJPEG="/usr"
      BF_OPENJPEG_INC="/usr/include"
      BF_OPENJPEG_LIB="openjpeg"
   EOF

   # FIX: littlecms includes path aren't specified
   if use lcms; then
      cat <<- EOF >> "${S}"/user-config.py
         BF_LCMS_INC="/usr/include/"
         BF_LCMS_LIB="lcms"
         BF_LCMS_LIBPATH="/usr/lib/"
      EOF
   fi

   # add system sci-physic/bullet into Scons build options.
#   cat <<- EOF >> "${S}"/user-config.py
#      WITH_BF_BULLET=1
#      BF_BULLET="/usr/include"
#      BF_BULLET_INC="/usr/include /usr/include/BulletCollision /usr/include/BulletDynamics /usr/include/LinearMath /usr/include/BulletSoftBody"
#      BF_BULLET_LIB="BulletSoftBody BulletDynamics BulletCollision LinearMath"
#   EOF

   #add iconv into Scons build options.
   if use !elibc_glibc && use !elibc_uclibc && use iconv; then
      cat <<- EOF >> "${S}"/user-config.py
         WITH_BF_ICONV=1
         BF_ICONV="/usr"
      EOF
   fi

   # configure Elbeem fluid system
   use elbeem || echo "BF_NO_ELBEEM=1" >> "${S}"/user-config.py

   # configure Tweak Mode
   use tweak-mode && echo "BF_TWEAK_MODE=1" >> "${S}"/user-config.py

   # FIX: Game Engine module needs to be active to build the Blender Player
   if ! use game-engine && use player; then
      elog "Forcing Game Engine [+game-engine] as required by Blender Player [+player]"
      echo "WITH_BF_GAMEENGINE=1" >> "${S}"/user-config.py
   else
      blend_with game-engine gameengine
   fi

   # set CFLAGS used in /etc/make.conf correctly
   echo "CFLAGS=[`for i in ${CFLAGS[@]}; do printf "%s \'$i"\',; done`] " \
      | sed -e "s:,]: ]:" >> "${S}"/user-config.py

   # set CXXFLAGS used in /etc/make.conf correctly
   local FILTERED_CXXFLAGS="`for i in ${CXXFLAGS[@]}; do printf "%s \'$i"\',; done`"
   echo "CXXFLAGS=[${FILTERED_CXXFLAGS}]" | sed -e "s:,]: ]:" >> "${S}"/user-config.py
   echo "BGE_CXXFLAGS=[${FILTERED_CXXFLAGS}]" | sed -e "s:,]: ]:" >> "${S}"/user-config.py

   # reset general options passed to the C/C++ compilers (useless hardcoded flags)
   # FIX: forcing '-funsigned-char' fixes an anti-aliasing issue with menu
   # shadows, see bug #276338 for reference
   echo "CCFLAGS= ['-funsigned-char', '-D_LARGEFILE_SOURCE', '-D_FILE_OFFSET_BITS=64']" >> "${S}"/user-config.py

   # set LDFLAGS used in /etc/make.conf correctly
   local FILTERED_LDFLAGS="`for i in ${LDFLAGS[@]}; do printf "%s \'$i"\',; done`"
   echo "LINKFLAGS=[${FILTERED_LDFLAGS}]" | sed -e "s:,]: ]:" >> "${S}"/user-config.py
   echo "PLATFORM_LINKFLAGS=[${FILTERED_LDFLAGS}]" | sed -e "s:,]: ]:" >> "${S}"/user-config.py

   # reset REL_* variables (useless hardcoded flags)
   cat <<- EOF >> "${S}"/user-config.py
      REL_CFLAGS=[]
      REL_CXXFLAGS=[]
      REL_CCFLAGS=[]
   EOF

   # reset warning flags (useless for NON blender developers)
   cat <<- EOF >> "${S}"/user-config.py
      C_WARN  =[ '-w', '-g0' ]
      CC_WARN =[ '-w', '-g0' ]
      CXX_WARN=[ '-w', '-g0' ]
   EOF

   # detecting -j value from MAKEOPTS
   local NUMJOBS="$( echo "${MAKEOPTS}" | sed -ne 's,.*-j\([[:digit:]]\+\).*,\1,p' )"
   [[ -z "${NUMJOBS}" ]] && NUMJOBS=1 # resetting to -j1 for empty MAKEOPTS

   # generic settings which differ from the defaults from linux2-config.py
   cat <<- EOF >> "${S}"/user-config.py
      BF_OPENGL_LIB='GL GLU X11 Xi GLEW'
      BF_INSTALLDIR="../install"
      WITHOUT_BF_PYTHON_INSTALL=1
      BF_PYTHON="/usr"
      BF_PYTHON_VERSION="3.2"
      BF_PYTHON_ABI_FLAGS=""
      BF_BUILDINFO=0
      BF_QUIET=1
      BF_NUMJOBS=${NUMJOBS}
      BF_LINE_OVERWRITE=0
      WITH_BF_FHS=1
      WITH_BF_BINRELOC=0
      WITH_BF_STATICOPENGL=0
      WITH_BF_OPENMP=${enable_openmp}
   EOF

   # configure WITH_BF* Scons build options
   for arg in \
      'sdl' \
      'apidoc docs' \
      'lcms' \
      'jack' \
      'sndfile' \
      'openexr' \
      'dds' \
      'fftw fftw3' \
      'jpeg2k openjpeg' \
      'openal'\
      'ffmpeg' \
      'ffmpeg ogg' \
      'player' \
      'collada' \
      'sse rayoptimization' \
      'redcode' \
      'zlib' ; do
      blend_with ${arg}
   done

   # enable debugging/testing support
   use debug && echo "BF_DEBUG=1" >> "${S}"/user-config.py
   use test && echo "BF_UNIT_TEST=1" >> "${S}"/user-config.py
}

src_compile() {
   scons || die \
      '!!! Please add "${S}/scons.config" when filing bugs reports \
      to bugs.gentoo.org'

   einfo "Building plugins ..."
   cd "${WORKDIR}"/${P}/release/plugins \
      || die "dir ${WORKDIR}/${P}/release/plugins do not exist"
   chmod 755 bmake

   # FIX: plugins are built without respecting user's LDFLAGS
   emake \
      CFLAGS="${CFLAGS} -fPIC" \
      LDFLAGS="$(raw-ldflags) -Bshareable" \
      > /dev/null \
      || die "plugins compilation failed"
}

src_install() {
   # creating binary wrapper
   cat <<- EOF >> "${WORKDIR}/install/blender-${SLOT}"
      #!/bin/sh

      # stop this script if the local blender path is a symlink
      if [ -L \${HOME}/.blender ]; then
         echo "Detected a symbolic link for \${HOME}/.blender"
         echo "Sorry, to avoid dangerous situations, the Blender binary can"
         echo "not be started until you have removed the symbolic link:"
         echo "  # rm -i \${HOME}/.blender"
         exit 1
      fi

      export BLENDER_SYSTEM_SCRIPTS="/usr/share/blender/${SLOT}/scripts"
        export BLENDER_SYSTEM_DATAFILES="/usr/share/blender/${SLOT}/datafiles"
         exec /usr/bin/blender-bin-${SLOT} \$*
   EOF

   # install binaries
   exeinto /usr/bin/
   mv "${WORKDIR}/install/blender" "${WORKDIR}/install/blender-bin-${SLOT}"
   doexe "${WORKDIR}/install/blender-bin-${SLOT}"
   doexe "${WORKDIR}/install/blender-${SLOT}"
   if use player; then
      mv "${WORKDIR}/install/blenderplayer" \
         "${WORKDIR}/install/blenderplayer-${SLOT}"
      doexe "${WORKDIR}/install/blenderplayer-${SLOT}"
   fi

   # install plugins
#   exeinto /usr/share/${PN}/${SLOT}/textures
#   doexe "${WORKDIR}"/${P}/release/plugins/texture/*.so
#   exeinto /usr/share/${PN}/${SLOT}/sequences
#   doexe "${WORKDIR}"/${P}/release/plugins/sequence/*.so
#   insinto /usr/include/${PN}/${SLOT}
#   doins "${WORKDIR}"/${P}/release/plugins/include/*.h
#   rm -r "${WORKDIR}"/${P}/release/plugins || die



   # install desktop file
   insinto /usr/share/pixmaps
   cp release/freedesktop/icons/scalable/apps/blender.svg \
      release/freedesktop/icons/scalable/apps/blender-${SLOT}.svg
   doins release/freedesktop/icons/scalable/apps/blender-${SLOT}.svg
   insinto /usr/share/applications
   cp release/freedesktop/blender.desktop \
      release/freedesktop/blender-${SLOT}.desktop
   doins release/freedesktop/blender-${SLOT}.desktop

   # install docs
#   use doc && dodoc release/text/BlenderQuickStart.pdf
   if use apidoc; then

      einfo "Generating (BGE) Blender Game Engine API docs ..."
      docinto "API/BGE_API"
      dohtml -r "${WORKDIR}"/${P}/doc/*

#      einfo "Generating (BPY) Blender Python API docs ..."
#      epydoc source/blender/python/doc/*.py -v \
#         -o doc/BPY_API \
#         --quiet --quiet --quiet \
#         --simple-term \
#         --inheritance=included \
#         --graph=all \
#         --dotpath /usr/bin/dot \
#         || die "epydoc failed."
#      docinto "API/python"
#      dohtml -r doc/BPY_API/*

      einfo "Generating Blender C/C++ API docs ..."
      pushd "${WORKDIR}"/${P}/doc/doxygen > /dev/null
         doxygen -u Doxyfile
         doxygen || die "doxygen failed to build API docs."
         docinto "API/blender"
         dohtml -r html/*
      popd > /dev/null

#      rm -r "${WORKDIR}"/${P}/doc
   fi

   # final cleanup
   rm -r "${WORKDIR}"/install/{Python-license.txt,icons,GPL-license.txt,copyright.txt}

   # installing blender
   insinto /usr/share/${PN}/${SLOT}
   doins -r "${WORKDIR}"/install/2.58/* || die

   # FIX: making all python scripts readable only by group 'users',
   #      so nobody can modify scripts apart root user, but python
   #      cache (*.pyc) can be written and shared across the users.
   chown root:users -R "${D}/usr/share/${PN}/${SLOT}/scripts" || die
   chmod 755 -R "${D}/usr/share/${PN}/${SLOT}/scripts" || die
}

pkg_preinst() {
   if [ -h "${ROOT}/usr/$(get_libdir)/blender/plugins/include" ];
   then
      rm -r "${ROOT}"/usr/$(get_libdir)/blender/plugins/include
   fi
}

pkg_postinst() {
   echo
   elog "Blender uses python integration. As such, may have some"
   elog "inherit risks with running unknown python scripting."
   elog
   elog "It is recommended to change your blender temp directory"
   elog "from /tmp to /home/user/tmp or another tmp file under your"
   elog "home directory. This can be done by starting blender, then"
   elog "dragging the main menu down do display all paths."
   elog
   elog "Blender has its own internal rendering engine but you"
   elog "can export to external renderers for image computation"
   elog "like: YafRay[1], sunflow[2], PovRay[3] and luxrender[4]"
   elog
   elog "If you need one of them just emerge it:"
   elog "  [1] emerge -av media-gfx/yafray"
   elog "  [2] emerge -av media-gfx/sunflow"
   elog "  [3] emerge -av media-gfx/povray"
   elog "  [4] emerge -av media-gfx/luxrender"
   elog
   elog "When setting the Blender paths with the User Preferences"
   elog "dialog box, remember to NOT declare your home's paths as:"
   elog "~/.blender, but as: /home/user/.blender; in other words,"
   elog "DO NOT USE the tilde inside the paths, as Blender is not"
   elog "able to handle it, ignoring your customizations."
}


PARCHES, so mexi nos parches blender-2.5-doxyfile.patch e blender-2.5-ffmpeg.patch, o restante estão corretos:

blender-2.5-bmake.patch
Code:

--- blender/release/plugins/bmake   2010-03-21 17:44:20.500741049 +0100
+++ blender/release/plugins/bmake   2010-03-21 17:44:33.659740173 +0100
@@ -57,10 +57,10 @@
    LDFLAGS="-Bshareable";
 elif ( test $UNAME = "Linux" ) then
    CC="gcc";
-   CFLAGS="-fPIC -funsigned-char -O2";
+#   CFLAGS="-fPIC -funsigned-char -O2";
 
    LD="ld";
-   LDFLAGS="-Bshareable";
+#   LDFLAGS="-Bshareable";
 elif ( test $UNAME = "SunOS" ) then
    CC="cc";
    CFLAGS="-O";


blender-2.5-doxyfile.patch
Code:

--- blender-2.58a/doc/doxygen/Doxyfile   2011-07-11 23:27:33.975642545 -0300
+++ blender-2.58a/doc/doxygen/Doxyfile   2011-07-11 23:28:54.913642574 -0300
@@ -42,7 +42,7 @@
 # exceed 55 pixels and the maximum width should not exceed 200 pixels.
 # Doxygen will copy the logo to the output directory.
 
-PROJECT_LOGO           = ../../release/freedesktop/icons/48x48/blender.png
+PROJECT_LOGO           = ../../release/freedesktop/icons/48x48/apps/blender.png
 
 # The OUTPUT_DIRECTORY tag is used to specify the (relative or absolute)
 # base path where the generated documentation will be put.


blender-2.5-eigen.patch
Code:

--- intern/itasc/SConscript   2009-09-26 09:14:02.000000000 +0200
+++ intern/itasc/SConscript   2009-09-26 09:14:54.000000000 +0200
@@ -5,7 +5,8 @@
 sources += env.Glob('kdl/*.cpp')
 sources += env.Glob('kdl/utilities/*.cpp')
 
-incs = '. ../../extern/Eigen2'
+#incs = '. ../../extern/Eigen2'
+incs = '. /usr/include/eigen2'
 
 env.BlenderLib ('bf_ITASC', sources, Split(incs), [], libtype=['intern','player'], priority=[20,100] )
 
--- source/blender/ikplugin/SConscript
+++ source/blender/ikplugin/SConscript
@@ -4,6 +4,6 @@
 sources = env.Glob('intern/*.c') + env.Glob('intern/*.cpp')
 
 incs = '#/intern/guardedalloc #/intern/iksolver/extern ../makesdna ../blenlib'
-incs += ' ../blenkernel ../include ../ikplugin #/intern/itasc #/extern/Eigen2'
+incs += ' ../blenkernel ../include ../ikplugin #/intern/itasc /usr/include/eigen2'
 
 env.BlenderLib ( 'bf_ikplugin', sources, Split(incs), [], libtype=['core','player'], priority=[180, 190] )


blender-2.5-ffmpeg.patch
Code:

--- source/blender/blenkernel/intern/writeffmpeg.c   2011-06-22 12:23:10.000000000 -0300
+++ source/blender/blenkernel/intern/writeffmpeg.c   2011-07-08 12:24:17.000000000 -0300
@@ -2,7 +2,7 @@
  *  \ingroup bke
  */
 /*
- * $Id: writeffmpeg.c 36960 2011-05-27 23:33:40Z schlaile $
+ * $Id: writeffmpeg.c 37755 2011-06-23 16:10:48Z campbellbarton $
  *
  * ffmpeg-write support
  *
@@ -49,7 +49,9 @@
 
 #include "BLI_blenlib.h"
 
-#include "AUD_C-API.h" /* must be before BKE_sound.h for define */
+#ifdef WITH_AUDASPACE
+#  include "AUD_C-API.h"
+#endif
 
 #include "BKE_global.h"
 #include "BKE_idprop.h"
@@ -89,7 +91,9 @@
 static int audio_outbuf_size = 0;
 static double audio_time = 0.0f;
 
+#ifdef WITH_AUDASPACE
 static AUD_Device* audio_mixdown_device = 0;
+#endif
 
 #define FFMPEG_AUTOSPLIT_SIZE 2000000000
 
@@ -103,6 +107,7 @@
    }
 }
 
+#ifdef WITH_AUDASPACE
 static int write_audio_frame(void)
 {
    AVCodecContext* c = NULL;
@@ -145,6 +150,7 @@
    }
    return 0;
 }
+#endif // #ifdef WITH_AUDASPACE
 
 /* Allocate a temporary frame */
 static AVFrame* alloc_picture(int pix_fmt, int width, int height)
@@ -851,7 +857,7 @@
    ffmpeg_autosplit_count = 0;
 
    success = start_ffmpeg_impl(rd, rectx, recty, reports);
-
+#ifdef WITH_AUDASPACE
    if(audio_stream)
    {
       AVCodecContext* c = audio_stream->codec;
@@ -861,12 +867,13 @@
       specs.rate = rd->ffcodecdata.audio_mixrate;
       audio_mixdown_device = sound_mixdown(scene, specs, rd->sfra, rd->ffcodecdata.audio_volume);
    }
-
+#endif
    return success;
 }
 
 void end_ffmpeg(void);
 
+#ifdef WITH_AUDASPACE
 static void write_audio_frames(double to_pts)
 {
    int finished = 0;
@@ -878,6 +885,7 @@
       }
    }
 }
+#endif
 
 int append_ffmpeg(RenderData *rd, int frame, int *pixels, int rectx, int recty, ReportList *reports)
 {
@@ -905,8 +913,9 @@
       }
    }
 
+#ifdef WITH_AUDASPACE
    write_audio_frames((frame - rd->sfra) / (((double)rd->frs_sec) / rd->frs_sec_base));
-
+#endif
    return success;
 }
 
@@ -920,12 +929,14 @@
       write_audio_frames();
    }*/
 
+#ifdef WITH_AUDASPACE
    if(audio_mixdown_device)
    {
       AUD_closeReadDevice(audio_mixdown_device);
       audio_mixdown_device = 0;
    }
-   
+#endif
+
    if (video_stream && video_stream->codec) {
       fprintf(stderr, "Flushing delayed frames...\n");
       flush_ffmpeg ();       


blender-2.5-glew.patch
Code:

--- extern/SConscript
+++ extern/SConscript
@@ -2,8 +2,6 @@
 
 Import('env')
 
-SConscript(['glew/SConscript'])
-
 if env['WITH_BF_ELTOPO']:
     SConscript(['eltopo/SConscript'])

 if env['WITH_BF_BULLET']:
     SConscript(['bullet2/src/SConscript'])
 
--- source/blender/editors/include/BIF_gl.h
+++ source/blender/editors/include/BIF_gl.h
@@ -31,7 +31,7 @@
 #ifndef BIF_GL_H
 #define BIF_GL_H
 
-#include "GL/glew.h"
+#include <GL/glew.h>
 
    /*
     * these should be phased out. cpack should be replaced in


blender-desktop.patch
Code:

--- release/freedesktop/blender.desktop   2010-09-12 00:05:51.000000000 -0700
+++ release/freedesktop/blender.desktop   2010-09-12 00:07:32.000000000 -0700
@@ -1,5 +1,5 @@
 [Desktop Entry]
-Name=Blender
+Name=Blender-2.5
 GenericName=3D modeller
 GenericName[es]=modelador 3D
 GenericName[de]=3D Modellierer
@@ -7,8 +7,8 @@
 GenericName[ru]=Редактор 3D-моделей
 Comment=3D modeling, animation, rendering and post-production
 Comment[es]=modelado 3D, animación, renderizado y post-producción
-Exec=blender
-Icon=blender
+Exec=blender-2.5
+Icon=blender-2.5
 Terminal=false
 Type=Application
 Categories=Graphics;3DGraphics;
Back to top
View user's profile Send private message
Display posts from previous:   
Reply to topic    Gentoo Forums Forum Index Portuguese All times are GMT
Page 1 of 1

 
Jump to:  
You cannot post new topics in this forum
You cannot reply to topics in this forum
You cannot edit your posts in this forum
You cannot delete your posts in this forum
You cannot vote in polls in this forum